=== debian/changelog ===
librsync (2.3.4-1.1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:57:38 +0000

librsync (2.3.4-1.1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - build without libb2 support (universe)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 29 Feb 2024 17:23:09 +0100

librsync (2.3.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062614

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 17:29:13 +0000

librsync (2.3.4-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - build without libb2 support (universe)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 13 Jun 2023 08:33:45 +0200

librsync (2.3.4-1) unstable; urgency=medium

  * New upstream version.
  * Bump Standards-Version to 4.6.2.

 -- Andrey Rakhmatullin <wrar@debian.org>  Mon, 12 Jun 2023 21:16:49 +0400

librsync (2.3.2-1ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - temporarly build without libb to unblock deja-dup, the library is
      optional and in universe at the moment
    - keep Ubuntu tarball, its different from the Debian one

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 24 Jan 2022 09:32:07 +0100

librsync (2.3.2-0ubuntu2) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:17:58 +0200

librsync (2.3.2-0ubuntu1) impish; urgency=medium

  * New upstream version

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 28 May 2021 16:06:15 +0200

librsync (2.3.1-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - temporarly build without libb to unblock deja-dup, the library is
      optional and in universe at the moment

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 18 Jan 2021 22:29:50 +0100
